Single click vs double-click
Closed, InvalidPublic

Description

It's clear from the conversation in T7928 that this needs more discussion. Let's do it here:

Advantages of status quo (single-click to open)

  • Makes opening files and folders much easier for users with poor dexterity or mousing skills, laptop trackpads, and touchscreens in particular (where double-clicking is practically impossible).
  • More intuitive; many users on other platforms have never fully understood when they need to double-click, and end up cringe-inducingly double-clicking everything "just to be safe."
  • More consistent with mobile, where double-clicking doesn't exist. Vastly more touch-friendly.

Disadvantages of status quo

  • Unfamiliarity for users migrating from all other desktop platforms, which all select with single click and open with double-click. We discard up to 30+ years of muscle memory.
  • Makes selection much more difficult by reducing the click target to a tiny square in the corner. For touch users, it's literally impossible, since the selection marker only appears on hover, and there is no hover with touch.
  • Makes multi-selection in file open dialogs infuriating, since no selection marker appears and there is no visible method to select multiple files.
  • Makes file save dialogs confusing. Single-clicking on a file suddenly no longer opens it. Why? Not clear. The UX breaks down.

Discussion

Let me mention that I actually really like the single-click setting. I just think it can't work without a lot of engineering effort put into resolving the above issues. Because right now, it's half-baked, halfhearted, and riddled with bugs. If someone proposed it in a patch today, we would block it on the above-mentioned objections, and possibly more.

If we're going to keep the feature used by default, then we need to make it work properly, and resolve the UX issues I detailed above. Mobile OSs that implement single-click-to-open (as well as GNOME apps) typically expose a dedicated "selection mode" that's invoked by pressing a "select" or "edit" button, and while in that mode, buttons for cut copy, paste, delete, and other contextually-appropriate actions become visible. If we're going to stay down this path, we need to be all in; the tiny little green selection button in the corner is not sufficient. We need to do serious usability and engineering work to accommodate common workflows in single-click mode vastly better than we do now.

If we aren't willing to do that or lack the resources, then we should consider it an experimental feature and not have it on by default, and not break people's muscle memory and experience for the sake of exposing them to a buggy, half-baked UX.

abetts added a subscriber: abetts.Mar 12 2018, 2:28 PM

Do you feel we have to choose one or the other? Is there room for having both methods changing depending on the device they are on?

Do you feel we have to choose one or the other? Is there room for having both methods changing depending on the device they are on?

Right now we do. It's a global setting, and single-click is the default. Device introspection is a slippery slope: I have a convertible laptop and I can tap the screen when it's in laptop mode; what mode should it use? Ideally we have a UI that seamlessly accommodates all use cases and form factors without explicitly switching behavior.

Do you feel we have to choose one or the other? Is there room for having both methods changing depending on the device they are on?

Right now we do. It's a global setting, and single-click is the default. Device introspection is a slippery slope: I have a convertible laptop and I can tap the screen when it's in laptop mode; what mode should it use? Ideally we have a UI that seamlessly accommodates all use cases and form factors without explicitly switching behavior.

Oh yeah. That's kind of a given. If you have a convertible, then convert the OS to behave automatically.

If only we had some way to ask the user how they would like plasma to look and feel when you make their account....

mmustac added a subscriber: mmustac.EditedMar 12 2018, 2:41 PM

When I started using Plasma I was really confused about the single click feature (I know where to change it) but I took this challenge and now I just don't want to go back anymore even I use Windows on the other hand with the double click enabled. I can conform the mentioned issue above regarding the multi selection in the file open dialog. I know to press Ctrl or Shift and slect more than one file but it's just not so discoverable. On Windows I love the option which display additional checkboxes to select multiple files.

rkflx added a subscriber: raddison.Mar 12 2018, 2:48 PM

Thanks Nate for trying to discuss this properly. For now just one note:

If we aren't willing to do that or lack the resources, then we should consider it an experimental feature and not have it on by default, and not break people's muscle memory and experience for the sake of exposing them to a buggy, half-baked UX.

Claiming something is half-baked and experimental is something I'd associate with some newer QML apps, but not for an interaction pattern in use for more than 20 years in KDE and longer elsewhere. Also, blackmailing developers of the existing UI to do changes, or otherwise you just switch the default, is hardly a good way to make you reach a consensus in the wider community.


As for the topic, let me move over what I stated in the Kubuntu task:

+1 for single click. An extra click does not improve usability. As a former Windows user, I had no difficulty to adapt to single click.

That's absolutely correct, because double-clicking makes the most common use case of activation much harder than the much less common use case of selection.

That's why the overlay buttons in Dolphin and Plasma are laid out like they are: A large target area for the common use case of activation, a small target area (the plus icon) for the less common use case of selection.

If selection is perceived as a problem, it should be investigated how to make selecting easier, not how to make activation harder. For a start, the plus icon could be improved in visibility (e.g. see how Windows Explorer displays the checkmark if you activate the corresponding setting), and once a single item is selected, the plus icon on all other items could me made much bigger (e.g. see how Windows Photos implements this).


More notes:
Notice how by default for the newer Photos app Microsoft have activated the selection markers, while for the legacy Explorer, you have to set them up manually. I bet if they could start over, they would default to the newer way.

Makes multi-selection in file open dialogs infuriating, since no selection marker appears and there is no visible method to select multiple files.

That's bad indeed, but this might be a bug, because I remember this working at some point (hopefully I did not mix this up).

Makes file save dialogs confusing. Single-clicking on a file suddenly no longer opens it. Why? Not clear. The UX breaks down.

Hmh, I have never seen users struggle with this. The normal click should perform the primary action, which is activation for Dolphin, and activation for folders in the file dialog, and selection for files in the file dialog. It's not true that the UX breaks down for folders in the file dialog.


Yes, we can make improvements. No, this is not a topic where we should change defaults back and forth every few months. Better work on the improvements and keep the status quo for now, I'd say.

It's commonly known KDE has single click, and newcomers will get to know it rapidly. I want to win them over, not adapt to their preconceptions, because I'm deeply convinced single-click is the only real way™ ;)

Obviously more people need to chime in…

rkflx added a comment.Mar 12 2018, 2:49 PM

@mmustac Yes, that's exactly what I wrote in the other task. See my GIF ;)

In T8187#132400, @rkflx wrote:

It's commonly known KDE has single click, and newcomers will get to know it rapidly. I want to win them over, not adapt to their preconceptions, because I'm deeply convinced single-click is the only real way™ ;)

It might not be obvious, but I am too. I just think we need a lot more work to make it shine. The feature has definitely been half-baked for 20 years. History is irrelevant; usability is king. If we're going to keep single-click be the default, then we need to fully commit to it throughout the UI, which we haven't done. I'm happy to start filin bugs and submitting patches, but we need to have a discussion about what that entails.

Do you feel we have to choose one or the other? Is there room for having both methods changing depending on the device they are on?

Right now we do. It's a global setting, and single-click is the default. Device introspection is a slippery slope: I have a convertible laptop and I can tap the screen when it's in laptop mode; what mode should it use? Ideally we have a UI that seamlessly accommodates all use cases and form factors without explicitly switching behavior.

Oh yeah. That's kind of a given. If you have a convertible, then convert the OS to behave automatically.

Although I am in support of double-click to help win over new users with a more familiar experience, this is a good point. I have a touchscreen laptop. I would actually really like it to be single-click when using the touch screen, and double-click when using the mouse. Is that weird? LOL.

But it would be cool if Plasma could be different based on input system. That way traditional desktop computing is one way, and mobile/touch is another way. Kind of how Kirigami is designed.

michaeltunnell added a comment.EditedMar 12 2018, 3:07 PM

@ngraham laptop trackpads would be fine if tap-to-click was enabled by default. That's what most people expect anyway.
Mobile is important and Plasma Mobile should totally have single-click but I agree with @abetts that it would be ideal if it adjusted based on device.
I hadn't thought of the dialog functionality being opposite of the default thus being unintuitive. Good point.


@rizzitello if only Look and Feel themes were more comprehensive and useful with reasonable amount of documentation making it easier for people to make Look and Feel themes . . . but alas. :) . . . I mean seriously, this page lists the resource types (.knsrc) and doesn't explain any of them . . . cgcicon.knsrc for example, it could at least explain what cgc means.


@mmustac I agree with most of what you said. Most people are confused by single click . . . if people give it a try they might like it but most people won't give it a try. Ctrl and Shift are useful but 99% of people will have never heard of that functionality and it is practically impossible to randomly discover it. The checkbox thing would be nice in list display in Dolphin, maybe that could be a different discussion in Phabricator. :)


@rkflx

That's absolutely correct, because double-clicking makes the most common use case of activation much harder than the much less common use case of selection.

The most more common usecase is double-click by default, it is what is expected. That alone should be the reason to use it, forcing people to deal with something so fundamental or change it so early on in the usage of Plasma is why some people stop using Plasma.

That's why the overlay buttons in Dolphin and Plasma are laid out like they are

The overlay of Plus and Minus buttons is not intuitive either and should be a checkbox instead like you demonstrated how Windows does it in the GIF.

It's commonly known KDE has single click, and newcomers will get to know it rapidly. I want to win them over, not adapt to their preconceptions, because I'm deeply convinced single-click is the only real way™ ;)

It is not commonly known by anyone in the Windows world who has not tried Plasma before. Yes, many people in the Linux world are aware of it being the default and the vast majority of them use it as a talking point to explain why Plasma's defaults are bad.

Newcomers most often don't "get to know it rapidly", they get to leaving Plasma rapidly.


@ngraham "History is irrelevant; usability is king.", agreed! Though I'd say expectation of usability is queen because forcing customization of something so fundamental and so uncommon by default is problematic.

@michaeltunnell Sorry not the Look and feel but a Way to allow the users to configure this upon their first login ... Other wise know as the wizard everyone seams to hate. Every time we talk about changing some default I keep coming back to you can please everyone so why not just ask on their first login.. Yes our Look and Feel should be updated and easier to understand and maybe that is part of the solution for some of these default discussion we keep having.

Back on topic....

Where exactly are we talking about the use of single vs double click ?
In File Management?
In Menus?
In Plasmashell?
In Applicaions buttons(see clam Tk gui all buttons are double click to use)
Should everything be double or single click ? is there a reason that somethings are one way and others the other ?

@rizzitello

Every time we talk about changing some default I keep coming back to you can please everyone so why not just ask on their first login.. Yes our Look and Feel should be updated and easier to understand and maybe that is part of the solution for some of these default discussion we keep having.

There are a lot of people who don't want to make the decision themselves and just want it to be expected as "out of the box". With that said, I think Look and Feel would not be a practical option for this because Look and Feel is really better for at a glance layout switching than anything else, this is too fine grained of a option to be in that approach.

Where exactly are we talking about the use of single vs double click ?

The original task proposed was referring to files, folders, icons, etc in file managers and on the desktop. Only items that are expected to be double-click by Windows to Linux switchers. Menus, application buttons, etc wouldn't be affected by this change.

ngraham added a comment.EditedMar 12 2018, 4:10 PM

Let's not discuss wizards here. The concept is DOA.

Basically we need to answer the following question:

Given that our default single-click setting is different from all other Desktop platforms, do the purported usability gains outweigh the impact of presenting an unfamiliar UI to users migrating from any of platforms?

This is the bar we need to hurdle. It doesn't matter what we've done for 20 years. It doesn't matter what the current default is. What matters to our users is whether or not the default setting offers enough superior usability despite its potential unfamiliarity to avoid irritating them and driving them away from Plasma and KDE software. I laid out the usability pros and cons of both settings above.

  • If we decide that the usability gains for single-click are currently greater than the drawback of presenting an unfamiliar UI, then we should keep the current setting.
  • If we decide that the usability gains for single-click are not but could be greater than drawback of presenting an unfamiliar UI, then we should keep the current setting and make changes to improve the usability.
  • If we decide that the usability gains for single-click are not greater than drawback of presenting an unfamiliar UI, and we lack the resources to fix this or the consensus on how to proceed, then we should change the setting to double-click for new users in a nod to user familiarity over the cardinal ideal.

Here are some references throughout the years of people complaining about the default not being double-click. This is not an exhaustive list but the intent here is to show how often it comes up and how long it has been a paper cut for so many.

2007 - HowToGeek - https://www.howtogeek.com/howto/ubuntu/disable-single-click-opening-of-files-in-kde/

Having switched from Ubuntu to Kubuntu recently, the first thing that irritated me beyond all reason was that single-clicking on a file or folder immediately opens the file instead of selecting it.


2009 - Ubuntu Forums - https://ubuntuforums.org/showthread.php?t=1262994

im used to double click icons to make them open where as in kde its just one click how can i set it to double click as i keep accidentally opening files.


2010 - AskUbuntu - https://askubuntu.com/questions/14048/how-to-disable-single-mouse-click-folder-opening

I am not able to select a folder (it always opens the folder). Right now to select I am using keyboard.


2011 - openSUSE Forum - https://forums.opensuse.org/showthread.php/453811-KDE-set-double-click

  • this one is to ask why the change to double-click isn't working for them . . . so no quote but is relevant.

2014 - BleepingComputer - https://www.bleepingcomputer.com/forums/t/531344/open-files-and-folders-with-a-double-click-in-kde/

If you are like me and hate the single click to open a folder or file and want to change it to double click. (followed by a tutorial)


2015 - PCLinuxOS - http://www.pclinuxos.com/forum/index.php?topic=135204.0

After having installed PCLinuxOS KDE64 on my brand new computer, I again stumbled across this “problem” (at least as former Windows user) . . . I click once on an icon and immediately activate things . . . Is this normal Linux O.S. behaviour and if so, is it wise to get accustomed to it?

  • the interesting thing about this one is the people trying to convince why single-click is superior. They also incorrectly answer OP to say that single-click is normal Linux usage when in reality, no it is just a KDE thing.

2015 - KDE.org Forum - https://forum.kde.org/viewtopic.php?f=223&t=128669

  • there is no quote for this one because the thread is more about not being able to find the method of changing because there was a bug in Dolphin not displaying the configuration option a couple years ago. However, this thread still shows it was important enough for them to comment about it.

2016 - KDE.org Forum - https://forum.kde.org/viewtopic.php?f=83&t=135696

I find single click opening of files in Plasma is irritating and think that the users who desire to have a single click file opening fall into a minority of human computer interaction paradigms.

same thread, different user:

Agreed. Majority of desktop users have double-click by default. Deviating from the norm for no good reason just confuses people.


2016 - KDE.org Forum - https://forum.kde.org/viewtopic.php?f=225&t=136355

Coming from a windows environment, I am use to DOUBLE CLICKING to open everything.


2016 - Manjaro Forum - https://forum.manjaro.org/t/option-to-double-click-desktop-icons-in-kde/13075

Ok, so I like to double click my icons to activate them

  • this is another issue of someone having activated double-click but the desktop not behaving as expected.

2017 - Kubuntu Subreddit - https://www.reddit.com/r/Kubuntu/comments/6gffmh/double_click/

KDE/Kubuntu n00b here... how can I set the desktop icons to double click instead of single?


2017 - Linux Mint Forum - https://forums.linuxmint.com/viewtopic.php?f=56&t=253075

I'd like to install Mint KDE along side of Mint Mate. I booted up from the DVD, and the first thing I noticed that I didn't like was that desktop icons were opened with a single mouse click.

Right, all of those are a strong argument in favor of pre-existing user expectation.

The question is, is single-click worth overriding that pre-existing expectation because it provide net benefits that outweigh the drawbacks of having to explain this to every new user? Personally I think a case can be made that it can, but I don't think it does the way we currently have it implemented. Right now, we throw out user experience and familiarity in favor of a buggy, incomplete UI that doesn't even solve the problems it could solve (e.g. it's still no good for touch because selection becomes impossible).

This comment was removed by raddison.
michaeltunnell added a comment.EditedMar 12 2018, 8:31 PM

@ngraham

I think the experiment of single-click by default has had enough time that if it were to have changed the expectations of users then it would have already done it.

KDE/Plasma has had single-click as default for over a decade and the topic has been brought up on so many occasions and has hurt the initial experience of so many people that it has motivated tutorials and videos to change it. It has also made it a focal point of "things to do after installing Plasma" as well as a staple citation for a reason people give for why they stopped using Plasma. I am not saying people leave because of it but it is one of the factors that creates a "if I have to change something so essential, what else will I have to change" reaction.

I'll be open about something . . . I had this initial reaction towards Plasma many years ago. I tried it and had to change so much stuff to get it to a state where I was happy to start using it that I just decided to give up on it. It wasn't until many conversations with long-time Plasma fans that I finally decided to just ignore all of the paper cuts and try to see what made Plasma so great to them. I have been using Plasma since I made that decision to fully try it. However, I think most people aren't willing to ignore things that create a feeling of inevitable customizations. In fact, I wasn't willing to ignore it until after many efforts of others trying to convince me to.

Mobile platforms are becoming more popular so many users have their digital lives lived in single click. How long before people expect single click over double click? One arguments for double click is that you can first select an item before opening it. What exactly is the purpose of selecting a single item? Why click an item you do not plan to open? You can drag (to move) without selecting the item first. You do not need to select an item to have a context menu open with right click. It does not help the user select multiple items since holding ctrl or shift is needed. (or you can use the "+" ). If we had some long press to enable a multiple selection mode that would be nice. I think we need to see in what cases single click is failing and improve them.

Mobile platforms are becoming more popular so many users have their digital lives lived in single click. How long before people expect single click over double click? One arguments for double click

The only argument, really.

is that you can first select an item before opening it. What exactly is the purpose of selecting a single item?

To prepare for doing any of the following very common file operations:

  • Rename
  • Cut/copy/paste
  • Make a link
  • Apply a tag
  • View properties
  • Delete
  • etc.

Long press is no-go: nobody on mobile uses or understands it. It makes even less sense on the desktop.

I agree with you that the current single-click UI needs improvement to live up to its promises and potential. What I would like to see is a mobile-style dedicated selection UI where you enter a selection mode and can then click on the entire icons to select them (not just the little thingy in the corner). In this mode, actions would appear in a contextual toolbar or sidebar (or whatever), corresponding to all the things you can do with the selected files. Also selection tools such as select all select none and invert selection would appear, helping you make your selection (lack of these is a major headache on mobile UIs where you have to select more than like 5 things at a time, such as importing or exporting photos).

This would be touch-friendly, mobile-friendly, and new-user-friendly on the desktop. All use cases would be first-class citizens. Advanced users might even grow to like it over time, and could easily turn it off if they didn't (like they can right now).

Alas, we don't have this UI. But I would strongly support it, as it would go a long way to making single-click mode actually fulfill its usability goals. What it's hard for me to support is the current UI that lacks all niceties to accommodate the logical design conclusions of the single-click setting, yet makes it the default anyway. Selecting is tedious and error-prone, which makes virtually all file manipulation operating more difficult than necessary. And we still don't actually support touch properly, as selection becomes all but impossible.

A voluntary action precedes the double click: pointing. That's 3 actions in total. It's completely redundant and pointless. Windows has many good aspects about its UI, but double-clicking isn't one of them. Please understand that "most people" or "the norm" or call them as you wish are miss-clicking even on Windows, whether it's set to single or double.

ngraham updated the task description. (Show Details)Mar 12 2018, 9:39 PM

A voluntary action precedes the double click: pointing. That's 3 actions in total. It's completely redundant and pointless. Windows has many good aspects about its UI, but double-clicking isn't one of them. Please understand that "most people" or "the norm" or call them as you wish are miss-clicking even on Windows, whether it's set to single or double.

So you are advocating selecting on hover? How would that work with list views?

I've been using KDE software since around 2002, and Plasma since the very beginning. I think I never changed the default of single-click, but since I can't seem to find a setting for that, without consulting some of those "how-to"s I'll just assume so. Even when using Windows and before that Mac (and before that Coleco ADAM) I've never figured out when it is appropriate to double-click and when single. I'm sorry to say that in KDE software that sense of mild bewilderment is unchanged, which is why I often resort to the commandline when possible.

I hated Dolphin in the beginning but still am bamfoozled by the folder behavior. I *never knew* what the + meant! Fortunately I found or was told about shift+click and control+click long ago. I must agree that the checkmark is much more intuitive there (although I've rarely seen recent Windows). Someone in the Kubuntu thread about this subject said that 'our users are very well used to this and love it' - well, I'm used to feeling puzzled and mystified, but I don't change defaults and I don't leave because I love the community. Arguing that "we've always done it this way" is not a valid argument. How do we make our software powerful for ALL our users? Especially new ones. That should be our only talking point here.

I hope that we are scheduling some more usability testing workshops for Akademy, by the way. If we have to pay testers a small sum to show up for a day, fine. Let's spend our Pineapple funds for THAT. And film the sessions so that devels who can't attend can use the session material to Make Better Software. Please let's not argue with out users and former users.

@valorie's experience is exactly what I was talking about in T7928. If you want people to migrate to Linux for desktop use, you need to make it familiar. It may not be "the best" behavior, but you need to make them as comfortable as possible. Unfortunately (to some), that means replicating Windows/Mac behavior. If you have spent any time with an "average" computer user, you know very well that they will be exceptionally frustrated as stuff starts opening without reason (to them). They don't care if it is more efficient, they expect a computer's basic input to work the same, regardless of OS.

If you care about efficiency, that's great. Enable single-click. But don't force everyone wanting to try out a Plasma-powered Linux desktop to switch their brain over to a new interaction method.

System Settings > Hardware > Input Devices > Mouse > Mouse Controls This is a non-issue. Plasma is

simple by default and powerful when needed

Please let's not argue with out users and former users.

+1

rizzitello added a comment.EditedMar 13 2018, 1:27 PM

System Settings > Hardware > Input Devices > Mouse > Mouse Controls This is a non-issue. Plasma is

simple by default and powerful when needed

When you put it that way, your right there is not a debate. +1 for Double Click default. Everyone else does it on desktop we should too. The least disruptive way is to just set the related setting as default in new pofiles. This way anyone not making a new account will have their setting perserved. Then Ideally we would fix our input handling for touch independently of this mouse related option.

System Settings > Hardware > Input Devices > Mouse > Mouse Controls This is a non-issue. Plasma is

simple by default and powerful when needed

When you put it that way, your right there is not a debate. +1 for Double Click default. Everyone else does it on desktop we should too. The least disruptive way is to just set the related setting as default in new pofiles. This way anyone not making a new account will have their setting perserved. Then Ideally we would fix our input handling for touch independently of this mouse related option.

Yes, we never change existing users' settings.

raddison added a comment.EditedMar 13 2018, 5:47 PM

@ngraham If people want double click by default, I'm not opposing their desire. Too bad we can't clone Windows UI altogether.

Double Click default. Everyone else does it on desktop we should too.

@rizzitello By all means. +1 from me for double.

@michaeltunnell After some experimenting with the mouse, I think double-click is not a disaster. If you think it'll make Plasma more accessible to people, then I fully endorse this suggestion as well as any other suggestion that is meant to serve the same scope.

I also have to be honest to myself. I think double-click is nonsense. Especially when I'm contemplating the big picture.

rkflx added a comment.Mar 13 2018, 8:23 PM

Looks like we managed to convince virtually everyone in T8187: Single click vs double-click that Double-Click is a more appropriate default for new KDE users. That was an upstream discussion, so I think we're pretty safe doing this for Kubuntu (not that upstream should care anyway).

Do what you must do in Kubuntu, I won't comment on that.

Note I did not read all comments here fully yet nor had the time to reply, but only looking at the list of subscribers, calling this a conclusive "upstream discussion" is utterly wrong. This needs buy-in from Dolphin, Plasma and some of the core maintainers. I don't see too many of them in that list. You should bring this up on several mailing lists and give it some weeks before calling such a grave decision a conclusive "upstream discussion".

Note that I did not use the word "conclusive"; that was your addition. But don't worry, I'm not planning to try changing it here anytime soon, if at all.

We are planning to change it in Kubuntu though, and I think interested parties should all pay close attention to the results, because what we are going to do is in essence a gigantic usability study. Rather than being wedded to one setting or another, I plan to carefully scrutinize user and reviewer feedback, hopefully to arrive at one of the following conclusions:

  • Changing the default was a big win and improved the usability for new users -> start upstream discussion regarding changing it here too
  • Changing the default did not result in a measurable improvement for new users or merely substituted one issue for another -> start an initiative to improve the usability of Single-Click in Dolphin, Gwenview, file pickers, and folder view in particular.

If our results in Kubuntu are very positive, I would hope that folks here can accept that the single-click experiment was a failure, and that it's time to move on. However, if our results show the opposite, I fully intend to embrace the conclusion that we should double-down on single-click and improve the usability. In the end, our own egos and personal opinions should yield to the results of real-world user testing, and that's what Kubuntu plans to do here, for the benefit of all of KDE.

rkflx added a comment.Mar 13 2018, 8:49 PM

conclusive

Look at where I set my quotation marks ;) Anyway, I meant "managed to convince virtually everyone".

improved the usability for new users -> start upstream discussion regarding changing it here too

That's the essential part I object to: Experiences from new users which have only been shown one setting will not be of any use to draw conclusions regarding how in the long term (i.e. for not-so-new-anymore users) usability metrics (i.e. most commonly efficiency, effectiveness and satisfaction) will behave, also considering learning an unfamiliar interface takes time and won't be part of any quick hands-on reviews by the media and on Reddit.

That experiment is not really scientific. Of course Windows users will like it better, no need to test that out.

Defaults should be about the best setting overall, they are not the instrument of a conversion campaign to bring in Windows users.

In T8187#132626, @rkflx wrote:

conclusive

Look at where I set my quotation marks ;) Anyway, I meant "managed to convince virtually everyone".

improved the usability for new users -> start upstream discussion regarding changing it here too

That's the essential part I object to: Experiences from new users which have only been shown one setting will not be of any use to draw conclusions regarding how in the long term (i.e. for not-so-new-anymore users) usability metrics (i.e. most commonly efficiency, effectiveness and satisfaction) will behave, also considering learning an unfamiliar interface takes time and won't be part of any quick hands-on reviews by the media and on Reddit.

You're acting as if Double-Click is the experimental setting. On the contrary, if we look at the big picture (whole industry, whole desktop computing landscape), our use of Single-Click is the experiment, since we are the only desktop platform that is configured with Single-Click by default. The only other platform that uses Single-Click by default is mobile (single-tap?), where touch is the primary or even only input, and the whole idea of file management basically doesn't exist. That doesn't describe KDE Plasma today. Plasma is first and foremost a productivity platform for real people with real computers to get real work done.

We have had years to witness the results of our KDE-wide experiment with Single-Click-as-default. As @michaeltunnell pointed out, what we see is a never-ending stream of frustration and user support requests. These kinds of issues sap resources and kill buzz. It's really important to resolve the issues that we see generating user complaints over and over again. We need to be flexible and admit defeat rather than just tell them "you'll get used to it." What's more likely is that they'll get burned out and leave and start spreading negativity among their friends and internet compatriots.

That experiment is not really scientific. Of course Windows users will like it better, no need to test that out.

...And Mac users, and GNOME users, and Cinnamon and XFCE users...

Like I have said many times, I actually like Single-Click and would be fine with Single-Click-as-default if we had previously or were currently willing to put the effort into hugely improving its usability (see UI suggestions at the top of the Task). Absent that, all it amounts to is privileging one use case (opening) over all others (renaming, copying, deleting, tagging, linking, etc), without really solving problems for the touch use case (selection and manipulation becomes impossible), and with the added disadvantage of being irritatingly inconsistent with every single other desktop platform that a user might be migrating from.

I really respect your opinion, @rkflx. I hope we can find a way to see eye-to-eye on this matter.

ngraham updated the task description. (Show Details)Mar 13 2018, 9:08 PM

@ngraham reductio ad absurdum always works. So yeah +1

@ngraham reductio ad absurdum always works. So yeah +1

No, Nate's arguments contain multiple logical and methodical flaws. Apparently you don't want to see them, so I'm not going to waste my time here.

I've been single click for years and don't get why people want double click personally. I never really studied UX theory, so I have been reading a bit about the subject to be more useful in the VGD . The reading i've done has shown me that I (We) need to look more at what the new users expects. This should in the end should lead to less users being instantly turned off by the weird interactactions with plasma.

I've tortured myself enough. No, double click does not improve usability. My mind cannot override the overwhelming evidence.

Let me suggest a path forward for single-click: Here's an image of GNOME Photos (from the GNOME 3.28 release announcement), which has the kind of dedicated selection mode that I'm talking about:

In that selection mode, the whole icon becomes a click target, and you can see what's selected by the little checkboxes. I think this is a fantastic single-click-centric UI that the GNOME folks should be applauded for. With contextual action buttons that can perform operations on what's selected (cut/copy/paste/rename/delete etc) and some polish work (e.g. select all/de-select all; supporting selection ranges somehow; being able to enter and exit the selection mode with a keyboard shortcut), it would really shine as an actual productivity feature, too. This would IMHO address all usability problems with the current single-click feature and make it 100% touch-ready.

If all of our apps, dialogs, and user interfaces (e.g. Folder View) that supported single-click used a UI like this, I think single-click would be a perfectly acceptable default, and training new users to use it would be not only relatively easy, but also beneficial in the long-run.

If we want to double down on single-click, this seems like a sensible direction to me. Thoughts?

This comment was removed by raddison.
This comment was removed by raddison.
This comment was removed by raddison.
This comment was removed by raddison.

That experiment is not really scientific. Of course Windows users will like it better, no need to test that out.

That experiment is not really scientific. Of course some Windows users will like it better, no need to test that out.

Defaults should be about the best setting overall, they are not the instrument of a conversion campaign to bring in Windows users.

Defaults should be about the best setting overall, they are not the instrument of a conversion campaign to bring in Windows users who were never aware they could switch to single even in Windows and got used to a less-than-optimal default.

@ngraham
@michaeltunnell

If double click is the expected and/or optimal default, then why are a lot of Windows users asking about how to set it to single?

https://answers.microsoft.com/en-us/windows/forum/windows_7-desktop/change-mouse-double-click-to-single-click/bdfd7e3f-964a-4d00-bb9c-7203f523d02f
https://www.windows10forums.com/threads/single-click.326/
https://www.sevenforums.com/installation-setup/266206-changing-double-left-click-open-files-single-left-click.html
https://www.tenforums.com/tutorials/40271-open-items-single-click-double-click-windows-10-a.html
https://answers.microsoft.com/en-us/windows/forum/windows_8-desktop/how-do-i-change-mouse-to-single-click-in-windows-8/230820db-ee4a-4250-bf04-d656ec456dc0
http://www.thewindowsclub.com/how-to-change-double-click-to-single-click-to-open-files-folders-in-windows
(just a few links; I can do better)

Let me mention that I actually really like the single-click setting.

@ngraham
Then why are you overriding what you like/know to be the optimal default?
Also, even in Windows, users have adapted to changes much more radical than a click.
I like what you're doing for Kubuntu but have you considered breaking a known default might trigger opposite-to-expected reactions from current users?
Also, isn't Plasma meant to be cross-device? Why should people use different defaults depending on the device? Isn't a unified default (single tap on mobile and single click on desktop) preferable?

ngraham added a comment.EditedMar 20 2018, 5:49 PM

Let me mention that I actually really like the single-click setting.

@ngraham
Then why are you overriding what you like/know to be the optimal default?

I am trying to avoid the mistake of assuming the superiority of my own opinion. Otherwise it's easy to think your favorite settings are the ones that are best for everyone. Sometimes they might be, but sometimes they aren't. Knowing the difference takes empathy and UX design skills.

The problem is that right now it isn't an optimal default--even though it could be with more work. As I've written, I would fully support single-click if we did the requisite UI work to make it a first-class citizen. Right now we have a UI that's half-baked and simply replaces some problems with different ones. If we want to break consistency with the default setting for every other major platform, we need to make sure that we're presenting our users something that's better in every way, because breaking consistency (even consistency with something sub-optimal) is a high bar.

I am very interested in having that conversation and organizing work to improve single-click, as I believe that is the path forward for keeping the current default. In general, when people are arguing over two choices that are imperfect in different ways, the best long-term solution is to commit to one and improve it to solve its problems.

Also, isn't Plasma meant to be cross-device?

Yes, which is why the current single-click default isn't good enough: it makes selection nearly impossible for touch users. It just replaces one problem with another one.

Okay, so you really implemented double click. It's nonsense. So be it.

ngraham closed this task as Sealed.Apr 6 2018, 9:33 PM

What? No we didn't. This particular discussion pertains to KDE. It's only downstream in Kubuntu where we made that change. My personal conclusion from this discussion is not that we should move to double-click here in KDE, but rather that the UI surrounding and supporting apps that implement single-click could stand some improvement. I think I mentioned this about 10 times in the discussion, including many details as well as at least one screenshot of an app that I consider to be a more user-friendly in its single-click UX.

However, that's a long-term goal, and I personally don't have the time to work on it right now, and I'm not aware of anyone else working on it either.

It's nonsense. So be it.

Please keep the discussion technical.

ngraham changed the task status from Sealed to Invalid.Apr 6 2018, 9:34 PM

Whoops, I mis-clicked.

raddison moved this task from Backlog/Planned to Work in Progress on the VDG board.Apr 6 2018, 9:45 PM
raddison reopened this task as Open.

Okay, so you really implemented double click. It's nonsense. So be it.

Okay, so you really implemented double click in Kubuntu. Technically speaking, it's nonsense. But it's not the end of the world. Seemingly, we're humans after all. Driven by emotions.

Why did you re-open this task and put it in the Work In Progress category? Is there something further you'd like to do with it? If you'd like a task tracking the proposed UI improvements to support single-click, I'd prefer to discuss that matter in a new task; this one has too much prior discussion and baggage attached to it, and it will be hard for people to focus on the proposal instead of the controversy.

raddison removed a subscriber: raddison.Apr 6 2018, 10:08 PM
ngraham closed this task as Invalid.Apr 6 2018, 10:13 PM

Closing because the discussion here is probably not going to yield any more fruit. Let's focus on improving the single-click UX over time.

ngraham added a comment.EditedApr 20 2018, 4:31 AM

The GNOME Folks are considering adding a contextual action bar to Nautilus just like I proposed for Dolphin and Gwenview et al:

https://csorianognome.wordpress.com/2018/04/10/nautilus-adding-an-action-info-bar/

Something like this in our apps that support single-click would go a long way towards making Single-Click a first-class citizen by improving the usability for non-open actions.

Here's the follow-on discussion for how we can improve single-click: T9895: Improving single-click / creation of contextual action toolbars

New user friendliness: double-click must be learned

Yes and they already learned it by using Windows and/or MacOS. (flawed point)

Accessibility for children, the elderly, people with shaky hands, laptop users, and those with poor mouse skills

the people with shaky hands could be a factor but I don't see how the rest is a factor since most people would already be used to the double. The laptop thing is weird because I am not sure how that changes anything but ok.

Consistency with mobile and the web, where there is no double-click

This amuses me because mobile devices don't even use a mouse so the comparison there is rather pointless. (get it . . . no pointer? . . . #dadjokes)

Predictability: no question regarding what needs to be single-clicked and what needs to be double-clicked (we've all known people who double-click everything)

fair point but rarely does it matter if people double click stuff that doesn't need it.


Best of luck for those who insist on single click and hopefully they can find solutions for all the negatives for having it by default. I highly doubt it since it has been over a decade already but :fingers crossed:

clel added a subscriber: clel.Dec 15 2018, 2:28 PM

I came here from https://forum.kde.org/viewtopic.php?f=83&t=135696&p=408438 where I got when searching on previous discussions about making double click the default.

I agree that one should have some good reasons when deciding to behave differently from the rest.
While the discussion here tried to outline some of the reasons to me it still seems not really evaluated. Also I think that it is not enough for single click to simply have the behaviour of multi selections work better as @ngraham suggested, but that this needs to go further like also taking other places into consideration where the behaviour is or can be inconsistent as well as writing some article / wiki / help text to explain the decision to use single click instead of the double click standard.

After a short Google search I came accross two websites that both suggest to get rid of the double click stating that it only was introduced in the first place by Apple to be able to offer a mouse with only one button and naming some negative effects. So there are good arguments for a single click default, but there is still the other side of incompatibility and other things like harder file selection with some of them introduced "by design", so cannot get fixed. The two links:

Maybe this is not the correct place to live up the discussion again but I feel like this should be evaluated from a more objective point to come to a conclusion that can later be used in the proposed article / wiki / help text to explain the way of doing to the users.


Closing because the discussion here is probably not going to yield any more fruit. Let's focus on improving the single-click UX over time.

By all means. T9895: Improving single-click

clel added a subscriber: raddison.Jan 8 2019, 2:55 PM

@raddison If your comment was for me: I did not feel like the linked task represented the topic of my comment, so I went here, although already closed.

@clel No, it was for Mike.

[spam comment removed by sysadmin]